<template>
    <div class="page edit-note">
        <header>
            <h1>{{title}}</h1>
        </header>
        <div class="content">
            <div class="center">
                <p>Название заметки</p>
                <label>
                    <input type="text" placeholder="Название заметки" v-model="noteName">
                </label>
                <EditTodoList :todos="todos" :edit="edit" :parentId="id" />
            </div>
        </div>
        <footer>
            <div class="buttons" v-if="edit">
                <nuxt-link class="btn" to="/">Отменить изменения</nuxt-link>
                <button class="btn" @click="editNote" :disabled="noteName.length == 0">Сохранить</button>
                <button class="btn" @click="showPopup(true, id)">Удалить заметку</button>
            </div>
            <button v-else class="btn" @click="addNote" :disabled="noteName.length == 0">Сохранить</button>
        </footer>
        <PopupDelNote />
    </div>
</template>

<script>
    import EditTodoList from "../components/EditTodoList";
    import PopupDelNote from "../components/PopupDelNote";
    import {bus} from "./index";
    var cloneDeep = require('lodash.clonedeep');

    export default {
        data: function() {
            return {
                id: 0,
                title: 'Новая заметка',
                noteName: '',
                todos: [{id: 1, name: '', status: 0}],
                edit: false,
                delId: '',
            }
        },
        created() {
            /*задаем значения, если заметка уже существует*/
            this.getNoteData();
            bus.$on('refreshTodos', data => {
                this.getNoteData();
            });
        },
        components: {PopupDelNote, EditTodoList},
        methods: {
            /*записываем новую заметку*/
            addNote() {
                let newNote = {'id': this.id, 'name': this.noteName, 'todos': this.todos}
                this.$store.commit('setNewNote', newNote);
                this.$router.push('/')
            },
            /*записываем изменения в заметке*/
            editNote() {
                let newNote = {'id': this.id, 'name': this.noteName, 'todos': this.todos}
                this.$store.commit('editNote', newNote);
                this.$router.push('/')
            },
            /*показываем попап подтверждения удаления*/
            showPopup(val, delId) {
                bus.$emit('showDelPopup', {val: true, delId: delId, action: 'delNote'});
            },
            /*получаем данные существующей заметки*/
            getNoteData() {
                if (this.$route.query.id) {
                    let id = this.$route.query.id ? this.$route.query.id : '';
                    for (let note in this.$store.state.notes) {
                        if (this.$store.state.notes[note].id == Number(id)) {
                            this.id = this.$store.state.notes[note].id;
                            this.todos = cloneDeep(this.$store.state.notes[note].todos);
                            this.title = 'Редактирование заметки «' + this.$store.state.notes[note].name + '»';
                            this.noteName = this.$store.state.notes[note].name;
                            this.edit = true;
                        }
                    }
                }
                else {
                    if (this.$store.state.notes.length > 0) {
                        this.id = Number(this.$store.state.notes[this.$store.state.notes.length - 1].id)+1;
                    }
                }
            }
        },
    }
</script>
